using PizzeriaContracts.BindingModels;
using PizzeriaContracts.ViewModels;
using PizzeriaDataModels;
using System.ComponentModel.DataAnnotations;

namespace PizzeriaDatabaseImplement.models
{
    public class Order : IOrderModel
    {
        public int Id { get; private set; }
        [Required]
        public int PizzaId { get; private set; }

        [Required]
        public int ClientId { get; private set; }

        public int? ImplementerId { get; private set; }

        [Required]
        public int Count { get; private set; }

        [Required]
        public double Sum { get; private set; }

        [Required]
        public OrderStatus Status { get; private set; } = OrderStatus.Неизвестен;

        [Required]
        public DateTime DateCreate { get; private set; } = DateTime.Now;

        public DateTime? DateImplement { get; private set; }

        public virtual Pizza Pizza { get; set; } = new();
        public virtual Client Client { get; set; } = new();
        public virtual Implementer? Implementer { get; set; } = new();


        public static Order? Create(PizzeriaDatabase context, OrderBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Order()
            {
                Id = model.Id,
                PizzaId = model.PizzaId,
                Pizza = context.Pizzas.FirstOrDefault(x => x.Id == model.PizzaId),
                ClientId = model.ClientId,
                Client = context.Clients.FirstOrDefault(x => x.Id == model.ClientId),
                ImplementerId = model.ImplementerId,
                Implementer = context.Implementers.FirstOrDefault(x => x.Id == model.ImplementerId),
                Count = model.Count,
                Sum = model.Sum,
                Status = model.Status,
                DateCreate = model.DateCreate,
                DateImplement = model.DateImplement
            };
        }

        public void Update(OrderBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            ImplementerId = model.ImplementerId;
            Status = model.Status;
            if(DateImplement == null) DateImplement = model.DateImplement;
        }

        public OrderViewModel GetViewModel => new()
        {
            Id = Id,
            PizzaId = PizzaId,
            ClientId = ClientId,
            ImplementerId = ImplementerId,
            ImplementerFIO = Implementer?.ImplementerFIO,
            ClientFIO = Client.ClientFIO,
            PizzaName = Pizza.PizzaName,
            Count = Count,
            Sum = Sum,
            Status = Status,
            DateCreate = DateCreate,
            DateImplement = DateImplement
        };
    }
}
